;; -*- mode: clojure
(set-env!
 :source-paths    #{"src/clj" "src/cljc"}
 :resource-paths  #{"resources"}
 :dependencies '[[org.clojure/clojure "1.10.1"]
                 [com.fasterxml.jackson.core/jackson-annotations "2.10.0"]
                 [com.fasterxml.jackson.core/jackson-core "2.10.0"]
                 [com.fasterxml.jackson.core/jackson-databind "2.10.0"]
                 [com.walmartlabs/lacinia "0.36.0-alpha-2"]
                 [com.walmartlabs/lacinia "0.36.0-alpha-2"]
                 [com.walmartlabs/lacinia-pedestal "0.13.0-alpha-1"]
                 [com.walmartlabs/lacinia-pedestal "0.13.0-alpha-1"]
                 [cprop "0.1.14"]
                 [deraen/boot-sass "0.5.0"]
                 [domino/core "0.3.0"]
                 [clojurewerkz/neocons "3.2.0"]
                 [io.pedestal/pedestal.immutant "0.5.7"]
                 [io.pedestal/pedestal.jetty "0.5.7"]
                 [io.pedestal/pedestal.service "0.5.7"]
                 [io.pedestal/pedestal.service-tools "0.5.7"]
                 [javax.servlet/servlet-api "2.5"]
                 [manifold "0.1.8"]
                 [metosin/jsonista "0.2.5"]
                 [logback-bundle/core-bundle "0.3.0"]
                 [metosin/muuntaja "0.6.6"]
                 [metosin/reitit "0.3.10"]
                 [mount "0.1.16"]
                 [org.clojure/core.typed "0.6.0"]
                 [org.clojure/spec.alpha "0.2.176"]
                 [samestep/boot-refresh "0.1.0" :scope "test"]
                 [tolitius/boot-check "0.1.12"]
                 [metosin/reitit-pedestal "0.3.10"]])

(def version "0.1.0-SNAPSHOT")
(task-options! pom {:project 'redblackrose
                    :version (str version "-standalone")
                    :description "FIXME: write description"
                    :license {"Eclipse Public License" "http://www.eclipse.org/legal/epl-v10.html"}}
               jar {:main 'redblackrose.core}
               aot {:all true})

(require '[tolitius.boot-check :as check])
(require '[samestep.boot-refresh :refer [refresh]])

;; == Cider Support =======================================

(require 'boot.repl)
(swap! boot.repl/*default-dependencies*
       concat '[[cider/cider-nrepl "LATEST"]])

(swap! boot.repl/*default-middleware*
       conj 'cider.nrepl/cider-middleware)

;; -- My Tasks --------------------------------------------
(deftask check-sources []
  (set-env! :source-paths #{"src/clj" "src/cljc"}
            (comp
             (check/with-yagni)
             (check/with-eastwood)
             (check/with-kibit)
             (check/with-bikeshed))))

(deftask dev []
  (set-env!
   :dependencies '[])
  (check-sources)
  (watch)
  (refresh))

(deftask build
  "Build an uberjar of the project."
  []
  (check-sources)
  (comp (aot) (pom) (uber) (jar) (target)))

